/**
 * 1. Daten holen
 * 2. Daten parsen
 * 3. View aufbauen
 * 4. View Funktionalität
 * 5. los
 */

;(function($) {

	var kbb;
	kbb = this.kbb = {};
	kbb.widgetName = "Trashcan";

	kbb.editModeSize = 'L';
	kbb.infoModeSize = 'L';
	
	
	kbb.locale = "en";
	kbb.type = "large";
	kbb.dataPath = "data/";
	
	kbb.html = "";
	
	
	kbb.cleanOut = function() {

		$('.container').removeClass('full');
		KBBUTIL.log("full and clean done");
	};
	
	kbb.addEvents = function () {
		
		KBBUTIL.log("kbb.addEvents");
		
		
		var widget = KBBUTIL.getWidgetObject();
		
		NB.addObserver("dndDropEvent", function(evt) {

			//KBBUTIL.log("evt.eventData "+ evt.eventData);
			
			//KBBUTIL.log("evt " + evt);
			//KBBUTIL.log("evt.eventData " + evt.eventData);
			
			for(var guid in evt.eventData) {
				  
				//KBBUTIL.log("guid " + guid);
				
				var chk = NB.getObject(guid) ;
				//KBBUTIL.log(widget.guid + " guid " + guid);
				
				
				if(guid == widget.guid)
					continue;
				
				if(
						NB.getHostObject().contains(chk.x, chk.y) ||
						NB.getHostObject().contains(chk.x + 50, chk.y + 50) ||
						NB.getHostObject().contains(chk.x - 50 , chk.y - 50) 
				) {
					  
						//$('.container').addClass('full').delay(2500).removeClass('full');
						$('.container').addClass('full');
						
						setTimeout("kbb.cleanOut()", 500);
						
						//KBBUTIL.log("full and clean done");		
						
						/*
						$('#player').trigger("play");						
						$('#player').bind('ended', function(){
							
							$('.container').removeClass('full');
						});
						*/
						
						chk.deleteObject();
				}
			}
			
			
		  });
		
		
		
		//NEXT AND LAST STEP
		KBBUTIL.moveToBack();
	};
	
	
	kbb.getViewStage = function() {
		
		var html = "";
		
		
		//style="display:none"
		/*html = '<audio style="display:block" id="player"  controls="controls" preload="auto" autobuffer>' + 
				'<source src="' + kbb.dataPath + 'trashcan.wav" type="audio/wav" />' +				
			  	'<source src="' + kbb.dataPath + 'trashcan.ogg" type="audio/ogg" />' +
			  	'<source src="' + kbb.dataPath + 'trashcan.mp3" type="audio/mpeg" />' +
			  	'no sound support'+
				'</audio>';*/
		
		return html;
	};
	
	kbb.createView = function() {
	
		KBBUTIL.log("kbb.createView");
		
		kbb.html = '<section class="container">' +
			kbb.getViewStage() + 
			'<div class="clearer"></div>' + 
		'</section>';
		
		
		kbb.element.html(kbb.html);
		
		//NEXT STEP
		kbb.addEvents();
		
		KBBUTIL.infoModeSize = kbb.infoModeSize;
		KBBUTIL.addInfoMode();
	};
	
	
	$.fn.startUP = function(locale) {
		
		kbb.locale = locale;
		kbb.element = $(this);
		
		KBBUTIL.log(kbb.element);
		
		//NEXT STEP
		kbb.createView();
		NB.localization.translateHtmlElements();
	};
	
	
})(jQuery);


$('#widgetContainer').startUP(locale);