(function () {
	
	var KBBUTIL;
	KBBUTIL = this.KBBUTIL = {};

	KBBUTIL.editModeFormConfig = null;
	KBBUTIL.editModeSize = 'L';
	KBBUTIL.editModeSizes = new Object();
	KBBUTIL.editModeSizes.L = {width: 320, height: 450};
	KBBUTIL.editModeSizes.M = {width: 320, height: 320};
	KBBUTIL.editModeSizes.S = {width: 320, height: 230};	
	
	KBBUTIL.infoModeFormConfig = null;
	KBBUTIL.infoModeSize = 'L';
	KBBUTIL.infoModeSizes = new Object();
	KBBUTIL.infoModeSizes.L = {width: 320, height: 480};
	KBBUTIL.infoModeSizes.M = {width: 320, height: 350};
	KBBUTIL.infoModeSizes.S = {width: 320, height: 260};
	
	KBBUTIL.extractingType = "List";
//	KBBUTIL.extractingPositions = [{x:100,y:100}, {x:0, y:100}, {x:-100, y:100}, {x:-100, y:0}, {x:-100, y:-100}, {x:0, y:-100}, {x:100, y:-100} ];
	KBBUTIL.extractingPositions = [{x:0,y:20} ];
	
	
	
    KBBUTIL.log = function(line) {
    	
    	// Generic logging function
    	window.console && console.log(line);
    };
	
    
    KBBUTIL.init = function() {
    	
    	
    };

    
    KBBUTIL.getDecorator = function() {
    	
    	return "<g class='group' xml:id='annotation.SFFOFIPFIE8457916DK01P0PR' xbk_transform='rotate(0.00,7.75,7.75)'><path fill-rule='evenodd' slscaler='0.033333' d='M3.08 0.75 L12.65 0.75 L12.88 0.80 L13.30 0.91 L13.70 1.15 L13.89 1.26 L14.21 1.59 L14.45 1.96 L14.56 2.17 L14.68 2.59 L14.73 2.83 L14.73 2.94 L14.75 3.08 L14.75 12.42 L14.73 12.53 L14.73 12.65 L14.68 12.88 L14.56 13.30 L14.33 13.70 L14.21 13.89 L13.89 14.21 L13.51 14.45 L13.30 14.56 L12.88 14.68 L12.65 14.73 L12.53 14.73 L12.42 14.75 L3.08 14.75 L2.94 14.73 L2.83 14.73 L2.59 14.68 L2.17 14.56 L1.78 14.33 L1.59 14.21 L1.26 13.89 L1.03 13.51 L0.91 13.30 L0.80 12.88 L0.75 12.65 L0.75 2.83 L0.80 2.59 L0.91 2.17 L1.15 1.78 L1.26 1.59 L1.59 1.26 L1.96 1.03 L2.17 0.91 L2.59 0.80 L2.83 0.75 z' shapename='5' fill='#009300' st_id='2147483649' stroke='#009300' stroke-width='1' fade-time='6' fade-enable='0' RotationPoint='(7.749954,7.749847)' transform='rotate(0.00,7.75,7.75)' xml:id='annotation.R8L1F9C4F704LAF2PA3D0N15A' visible='1' /><path fill-rule='evenodd' slscaler='0.033333' d='M11.08 5.34 L6.56 11.08 L4.75 8.79 L5.22 8.20 L6.56 9.90 L10.62 4.75 z' shapename='3' fill='#ffffff' st_id='84' stroke='#ffffff' stroke-width='2' fade-time='6' fade-enable='0' RotationPoint='(7.916580,7.916779)' transform='rotate(0.00,7.92,7.92)' xml:id='annotation.QAC94GO2FN24D3DAMAE9DLVOD' visible='1' /></g>";
    	//return '<div style="width:10px;height:10px;background-color:lime;color:white;text-align:center;font-size:8px;">x</div>';
    };
    
    KBBUTIL.stripTags = function(str) {
    	
    	return str.replace(/(<([^>]+)>)/ig,"");
    };
    

	KBBUTIL.collision = function(chk, element) {
		
		var widget = KBBUTIL.getWidgetObject();
		
		$('#dragCheck').remove();
		var dragged = $('<div id="dragCheck">dragged</div>').appendTo('#editModeForm');
		dragged.css('left', chk.x - widget.x - 20 )
				.css('top', chk.y - widget.y - 80 )
				.css('width', chk.width)
				.css('height', chk.height)
				.css('position', 'absolute')
				.css('border', '1px solid green');
		
		var result = element.collidesWith('#dragCheck');
		
		$('#dragCheck').remove();
		
		if(result === null || result == "") return false;
		
		
		
		KBBUTIL.log("result " +result);
		for(var s in result) { KBBUTIL.log("result["+s+"] "+ result[s]);}
		
		return true;
	};
	/*
		//das zu testende object
		var widget = KBBUTIL.getWidgetObject();
		var drop = new Object();
		drop.x1 = chk.x - widget.x;
		drop.y1 = chk.y - widget.y;
		drop.x2 = chk.x + chk.width;
		drop.y2 = chk.y + chk.height;
		
		
		
		//das element, auf das evtl gedroppt wird
		var pos = element.position();
		if(pos === null) {
			
			//KBBUTIL.log("element.position() is null....stopping");
			return false;
		}
		
		//for(var e in pos) { KBBUTIL.log(e +" "+pos[e]);}
		
		
		var area = new Object();
		area.x1 = pos.top;
		area.y1 = pos.left;
		area.x2 = parseInt(pos.top) + parseInt(element.width() );
		area.y2 = parseInt(pos.left) + parseInt(element.height() );
		
if(element.attr('class') == 'adding') {
		
		KBBUTIL.log("element= "+ element.attr('class') + " "+ element.attr('id'));
		KBBUTIL.log("widget.x="+widget.x+", widget.y="+widget.y+", widget.width="+ widget.width+", widget.height="+widget.height);
		KBBUTIL.log("area.x1="+area.x1+", area.y1="+area.y1+", area.x2="+area.x2+", area.y2="+area.y2);
		KBBUTIL.log("drop.x1="+drop.x1+", drop.y1="+drop.y1);//+", drop.x2="+drop.x2+", drop.y2="+drop.y2

}				
		if( area.x1 < drop.x1 && area.y1 < drop.y1 && 
			area.x2 > drop.x1 && area.y2 > drop.y1) {
			
			KBBUTIL.log("drin");
			return true;
		}
			
		return false;
	};
    */
    
    
    KBBUTIL.save = function (key, val) {
    	
    	NB.persist.save(key, val);
    	
    	//KBBUTIL.log("KBBUTIL.load("+ key +")" + KBBUTIL.load(key) + " must be '"+ val +"'");
    };
    
    
    KBBUTIL.loadAll = function() {
    	
    	return NB.persist.list();
    };
 
    
    
    KBBUTIL.load = function(key) {
    	
    	var val = NB.persist.load(key);
    	if(val === undefined) return "not-found";
    	
    	if(val.indexOf('"') !== -1) {
    	
    		var len = val.length;
    		val = val.substr(1, len -2);
    	}
    	
    	
    	while(val.indexOf("\\") !== -1) {
    		
    		val = val.replace("\\", "");
    	}
    	
    	return val;
    };

    
    KBBUTIL.transparency = function() {

    	NB.settings.enableTransparentColorMask(255,255,254);
    };
    
    
    KBBUTIL.moveToBack = function() {
    	
    	var widget = KBBUTIL.getWidgetObject();
    	widget.moveToBack();
    };
    
    
    KBBUTIL.addEditMode = function(formConfig) {
    	
		if(formConfig.length == 0) 
			return;
    	
    	KBBUTIL.editModeFormConfig = formConfig;
    	jQuery.getScript("libs/editmode.js");
    	jQuery.getScript("libs/jquery-ui-1.9.1.custom.min.js");
    };
    
    
    KBBUTIL.addInfoMode = function() {
    	
    	jQuery.getScript("libs/infomode.js");
    };
    
    
    
    KBBUTIL.getObjectOnMe = function() {
    	
    	var objects = KBBUTIL.getAllPageObjects();
    	
    	for(var i=0; i<objects.length; i++) {
    		
    		var chk = objects[i];
    		if(NB.getHostObject().contains(chk.x, chk.y)) {
    			
    			return chk;
    		}
    	}
    	
    	return undefined;
    };
    

    

    
    KBBUTIL.createImageObject = function(str, props) {
    	
		/*no params = this widget and all page objects*/

    	var position = KBBUTIL.nextFreeSpace();

		props.x = position.x;
		props.y = position.y;
		
		if(props.myVal === undefined || props.myVal === null)
			props.myVal = str;
		
		//KBBUTIL.log("imageUrl " + kbb.dataPath + str + ".png");
		
		var prototype = new NB.objectPrototype.file( kbb.dataPath + str + ".png");
		prototype.x = props.x;
		prototype.y = props.y;
		
		return prototype;
    };
    
    
    KBBUTIL.createTextObject = function(str, props) {
    	
		/*no params = this widget and all page objects*/

    	var position = KBBUTIL.nextFreeSpace();
		//KBBUTIL.log("position " + position.x + " " + position.y);
		
		props.x = position.x;
		props.y = position.y;
		
		if(props.myVal === undefined || props.myVal === null)
			props.myVal = str;
		
		var prototype = NB.objectPrototype.text(str, props);
    	
		//prototype.setCustomProperty('myVal', str);
		
		return prototype;
    };
    
    
    KBBUTIL.stringToArray = function(str, splitter) {
    	
    	return str.split(splitter);
    };
    
    KBBUTIL.arrayToString = function(arr, glue) {
    	
    	return arr.join(glue);
    };

    
    KBBUTIL.inArray = function(item, arr) {
    	
    	for(var i=0; i<arr.length; i++) {
    		
    		if(arr[i] === item) return true;
    	}
    	
    	return false;
    };
    
    KBBUTIL.sortArrayByText = function(arr) {
    	
    	var titles = new Array();
    	var temp = new Object();
    	var sorted = new Array();
    	var title;
    	
    	for(var i=0; i<arr.length; i++) {
    		
    		title = arr[i].getText();
    		temp[title + '_' + i] = arr[i];
    		titles.push(title + '_' + i);
    	}
    	
    	titles.sort();
    	
KBBUTIL.log("sorted titles "+ titles);
    	
    	for(i=0; i<titles.length; i++) {
    		
//KBBUTIL.log("temp[titles[i]] "+ titles[i]);
    		sorted.push(temp[titles[i]]);
    	}

//    	KBBUTIL.log("sorted sorted "+ sorted);    	
    	
    	return sorted;
    };
    
    
    KBBUTIL.getAllTextPageObjects = function( includeHandwritten ) {
    	
    	includeHandwritten = (typeof includeHandwritten !== 'undefined' ) ? includeHandwritten : false;
    	var objects = NB.page.getObjectsAsArray();
    	var textObjects = new Array();
    	
    	for(var i=0; i<objects.length; i++) {

    		if(includeHandwritten && typeof objects[i].getText == "function" && objects[i].getText() != "") {
    			textObjects.push(objects[i]);
    		} else if ( objects[i].text !== undefined ) {
        		textObjects.push(objects[i]);
    		}
    	}
    	
    	return textObjects;
    };
    
    
    KBBUTIL.getAllSelectedTextPageObjects = function(includeHandwritten) {
    	
    	includeHandwritten = (typeof includeHandwritten !== 'undefined' ) ? includeHandwritten : false;
    	var objects = NB.page.getSelectedObjects();
    	var textObjects = new Array();
    	
    	for(var i=0; i<objects.length; i++) {
    	
    		if(includeHandwritten && typeof objects[i].getText == "function" && objects[i].getText() != "") {
    			textObjects.push(objects[i]);
    		} else if ( objects[i].text !== undefined ) {
        		textObjects.push(objects[i]);
    		}
    	}
    	
    	return textObjects;
    };
    
    

    KBBUTIL.getAllSelectedPageObjects = function() {
    	
    	var objects = NB.page.getSelectedObjects();
    	
    	var pageObjects = new Array();

    	for(var i=0; i<objects.length; i++) {
    		
    		if(objects[i].type === "widget" || objects[i].lockType !== "Unlock") 
    			continue;
    			
  			pageObjects.push(objects[i]);
    	}
    	
    	return pageObjects;
    };
    
    
    KBBUTIL.getAllPageObjects = function() {
    	
		var widget = KBBUTIL.getWidgetObject();
    	var objects = NB.page.getObjectsAsArray();
    	var pageObjects = new Array();

    	for(var i=0; i<objects.length; i++) {
    		
    		if(objects[i].guid === widget.guid) continue;
    		if(objects[i].type === "widget" || /*objects[i].lockType === "Lock In Place" ||*/ objects[i].lockType !== "Unlock") continue;        
    		
    		
    		pageObjects.push(objects[i]);
    	}
    	
    	return pageObjects;
    };
    
    
    KBBUTIL.getWidgetObject = function () {
    	
    	var widget = NB.getHostObject();
    	
    	return widget;
    };
    
    
    KBBUTIL.nextFreeSpace = function(me, checkItems) {
    	
    	/*fallback*/
    	me = (me === undefined || me === null) ? KBBUTIL.getWidgetObject() : me;
    	
    	checkItems = (checkItems === undefined || checkItems === null)
    		? KBBUTIL.getAllPageObjects() : checkItems;
    	checkItems.push(KBBUTIL.getWidgetObject());
    	/*fallback eof*/
    		
    	var position = new Object();
    	
    	var extractPositions = KBBUTIL.extractingPositions;
    	
    	var isFree = false;
    	var num = 1;
    	var offsetX;
    	var offsetY;
    	
    	while(isFree === false) {
    		
	    	for(var j=0; j<extractPositions.length; j++) {
	    		
	    		if(KBBUTIL.extractingType == "Circle") {
	    			
//	    			KBBUTIL.log("extractPositions[j] position("+extractPositions[j].x+", "+extractPositions[j].y+")");
//	    			KBBUTIL.log("AAAA position("+me.x+", "+me.y+")");
	    			
	    			position.x = me.x + parseInt(me.width/2);
	    			position.y = me.y + parseInt(me.height/2);
	    			
//	    			KBBUTIL.log("BBBBB position("+position.x+", "+position.y+")");
	    			
	    			position.x += parseInt(extractPositions[j].x);
	    			position.y += parseInt(extractPositions[j].y);
	    			
//	    			KBBUTIL.log("CCCC position("+position.x+", "+position.y+")");
	    			
	    			offsetX = 30 * num;
	    			offsetX = (extractPositions[j].x > 0) ? offsetX : offsetX*-1;
	    			
	    			offsetY = 30 * num;
	    			offsetY = (extractPositions[j].y > 0) ? offsetY : offsetY*-1;
	    			
	    			position.x+= offsetX;
	    			position.y+= offsetY;
	    			
//	    			KBBUTIL.log("DDDD position("+position.x+", "+position.y+")");
	    			
	    		} else {
	    			
		    		offsetX = extractPositions[j].x + parseInt(num * extractPositions[j].x);
		    		offsetY = extractPositions[j].y + parseInt(num * extractPositions[j].y);
		    		
			    	position.x = parseInt(me.x) + parseInt(me.width) + offsetX;
			    	position.y = parseInt(me.y) + parseInt(me.height) + offsetY;		    		
	    		}
		    	

//		    	KBBUTIL.log("position("+position.x+", "+position.y+")");

		    	if(KBBUTIL.extractingType == "Circle" && (position.x < 0 || position.y < 0 || position.x > 800 || position.y > 600)) { 
		    		
		    		num++;
		    		
		    		if(num > 100) 
		    			break;
		    		else
		    			continue;
		    	}		    	
		    	
		    	isFree = true;
		    	
		    	for(var i=0; i<checkItems.length; i++) {
		    		
		    		var item = checkItems[i];
		    		var txt = (item.text !== undefined) ? item.getText() : 'NOTEXT';
		    		txt = (txt === undefined) ? 'NOTEXT' : txt;
		    		
//		    		KBBUTIL.log("item "+item.x +"/"+item.y + " == " + item.contains(position.x, position.y) + " " + txt );
		    		
		    		if(item.contains(position.x, position.y) || ( position.x == item.x && position.y == item.y) ) {
		    			
		    			//KBBUTIL.log("item.contains("+position.x+", "+position.y+")....");
		    			isFree = false;
		    			break;
		    		}
		    	}
		    	
		    	
		    	if(isFree === true) {
		    		
//		    		KBBUTIL.log("returning position("+position.x+", "+position.y+")");
		    		return position;
		    	}
	    	}
	    	
	    	num++;
	    	
	    	if(num > 100) isFree = true;
    	}
    	
    	
    	return {x: Math.floor((Math.random()*750)+1), y:Math.floor((Math.random()*550)+1)};
    }; 
    
    KBBUTIL.init();
	
} )() ;